/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/controllers/DropMouseController.as
 * org.apache.royale.html.beads.controllers.DropMouseController
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.controllers.DropMouseController');

goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.css2.Cursors');
goog.require('org.apache.royale.events.DragEvent');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.events.MouseEvent');
goog.require('org.apache.royale.geom.Point');
goog.require('org.apache.royale.utils.PointUtils');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.html.beads.controllers.DropMouseController = function() {
  org.apache.royale.html.beads.controllers.DropMouseController.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.beads.controllers.DropMouseController, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.controllers.DropMouseController', org.apache.royale.html.beads.controllers.DropMouseController);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype._strand;


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.inside;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.dragSource;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.dragInitiator;


/**
 * @export
 * @param {org.apache.royale.core.IUIBase} target
 * @param {string} type
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.acceptDragDrop = function(target, type) {
};


/**
 *  @asprivate
 * @royaleignorecoercion org.apache.royale.events.MouseEvent
 * @private
 * @param {org.apache.royale.events.DragEvent} event
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.dragMoveHandler = function(event) {
  var /** @type {org.apache.royale.events.DragEvent} */ dragEvent;
  if (!this.inside) {
    dragEvent = org.apache.royale.events.DragEvent.createDragEvent("dragEnter", event);
    dragEvent.relatedObject = event.relatedObject;
    this.dispatchEvent(dragEvent);
    this.inside = true;
    org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).addEventListener(org.apache.royale.events.DragEvent.DRAG_END, org.apache.royale.utils.Language.closure(this.dragEndHandler, this, 'dragEndHandler'));
    org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).addEventListener(org.apache.royale.events.MouseEvent.ROLL_OUT, org.apache.royale.utils.Language.closure(this.rollOutHandler, this, 'rollOutHandler'));
    org.apache.royale.css2.Cursors.setCursor(org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase), org.apache.royale.css2.Cursors.MOVE);
  } else {
    dragEvent = org.apache.royale.events.DragEvent.createDragEvent("dragOver", event);
    dragEvent.relatedObject = event.relatedObject;
    this.dispatchEvent(dragEvent);
  }
};


/**
 * @private
 * @param {org.apache.royale.events.MouseEvent} event
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.rollOutHandler = function(event) {
  var /** @type {org.apache.royale.events.DragEvent} */ dragEvent;
  if (this.inside) {
    dragEvent = org.apache.royale.events.DragEvent.createDragEvent("dragExit", event);
    this.dispatchEvent(dragEvent);
    this.inside = false;
    org.apache.royale.css2.Cursors.setCursor(org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase), org.apache.royale.css2.Cursors.AUTO);
  }
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).removeEventListener(org.apache.royale.events.DragEvent.DRAG_END, org.apache.royale.utils.Language.closure(this.dragEndHandler, this, 'dragEndHandler'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).removeEventListener(org.apache.royale.events.MouseEvent.ROLL_OUT, org.apache.royale.utils.Language.closure(this.rollOutHandler, this, 'rollOutHandler'));
};


/**
 * @royaleignorecoercion org.apache.royale.events.MouseEvent
 * @private
 * @param {org.apache.royale.events.DragEvent} event
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.dragEndHandler = function(event) {
  var /** @type {org.apache.royale.events.DragEvent} */ dragEvent;
  var /** @type {org.apache.royale.geom.Point} */ screenPoint = new org.apache.royale.geom.Point(event.screenX, event.screenY);
  var /** @type {org.apache.royale.geom.Point} */ newPoint = org.apache.royale.utils.PointUtils.globalToLocal(screenPoint, this._strand);
  dragEvent = org.apache.royale.events.DragEvent.createDragEvent("dragDrop", event);
  dragEvent.clientX = newPoint.x;
  dragEvent.clientY = newPoint.y;
  
  dragEvent.relatedObject = event.relatedObject;
  this.dispatchEvent(dragEvent);
  this.inside = false;
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).removeEventListener(org.apache.royale.events.DragEvent.DRAG_END, org.apache.royale.utils.Language.closure(this.dragEndHandler, this, 'dragEndHandler'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase, true).removeEventListener(org.apache.royale.events.MouseEvent.ROLL_OUT, org.apache.royale.utils.Language.closure(this.rollOutHandler, this, 'rollOutHandler'));
  org.apache.royale.css2.Cursors.setCursor(org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase), org.apache.royale.css2.Cursors.AUTO);
};


org.apache.royale.html.beads.controllers.DropMouseController.prototype.get__strand = function() {
  return this._strand;
};


org.apache.royale.html.beads.controllers.DropMouseController.prototype.set__strand = function(value) {
  this._strand = value;
  
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher, true).addEventListener(org.apache.royale.events.DragEvent.DRAG_MOVE, org.apache.royale.utils.Language.closure(this.dragMoveHandler, this, 'dragMoveHandler'));
};


Object.defineProperties(org.apache.royale.html.beads.controllers.DropMouseController.prototype, /** @lends {org.apache.royale.html.beads.controllers.DropMouseController.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
get: org.apache.royale.html.beads.controllers.DropMouseController.prototype.get__strand,
set: org.apache.royale.html.beads.controllers.DropMouseController.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DropMouseController', qName: 'org.apache.royale.html.beads.controllers.DropMouseController', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.controllers.DropMouseController.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.controllers.DropMouseController'}
      };
    },
    methods: function () {
      return {
        'DropMouseController': { type: '', declaredBy: 'org.apache.royale.html.beads.controllers.DropMouseController'},
        'acceptDragDrop': { type: 'void', declaredBy: 'org.apache.royale.html.beads.controllers.DropMouseController', parameters: function () { return [  { index: 1, type: 'org.apache.royale.core.IUIBase', optional: false },{ index: 2, type: 'String', optional: false } ]; }}
      };
    },
    metadata: function () { return [  ]; }
  };
};